; dm2
; Averages for measurements of cochlear input impedance in cat,
; compared with model input impedance.
;
; part a:
;   x = frequency (kHz)
;   y = stapes pressure/tympanic membrane pressure (dB)
;
header=0 : clip=y : yhor=y
annsiz=-.14 : labsiz=-.14 : msgsiz=-.14 : sizfac=4
newframe
grid=0
xllc=2   : xlen=5 : xcycle=3 : xmin=0.02 : xmax=20.0 : xanskp=-1
yllc=3.5 : ylen=3 : ycycle=0 : ymin=-10 :  ymax=40 :  yanskp=0
;
pltype=lines only
lintyp=0
include dm2a.dat
plot
lintyp=8
include ../datman/dm2a.inc
plot
;
; part b:
;   x = frequency (kHz)
;   y = phase (degrees)
;
newframe
grid=0
xllc=2 : xlen=5 : xcycle=3 : xmin=0.02 : xmax=20.0 : xanskp=0
yllc=1 : ylen=2 : ycycle=0 : ymax= 180 : ymin=-180 : yint=2.2 : yper=90
;
pltype=lines only
lintyp=0
include dm2b.dat
plot
lintyp=8
include ../datman/dm2b.inc
plot

;
; labels
;
newframe
axlwt=0
xllc=0 : yllc=0 : xlen=10.5 : ylen=8 
xmin=0 : ymin=0 : xmax=10.5 : ymax=8 : xcyc=0 : ycyc=0

lintype=0
0.75, 1.00
0.75, 6.50
plot

mhal=cen : mval=bottom : msgangle=90 : msgsize=-.15
0.75 3.75 "pressure difference across cochlear partition"
1.00 3.75 "pressure at tympanic membrane"
msgsiz=-.14
1.40 5.00 "magnitude (dB)"
1.40 2.00 "phase (deg)"
msgangle=0 : msgsiz=-.14
4.0  0.4  "frequency (kHz)"

mhal=left : mval=base : msgangle=0 : msgsiz=-.13
3.5 4.00 "|_0| model"
3.5 3.75 "|_8| Nedselnitsky (1980)"
2.15 3.7 "(a)"
2.15 1.2 "(b)"

;9.5 0.1 "tdm 2"
