/* wrparm.c  - write parameters from tdm data files */

#include <stdlib.h>
#include <stdio.h>
#include "tdmdef.h"
#define MAIN
#include "cparam.h"
#include "ctdmio.h"

void error();
void swab();
void usage();
void wrpar();

void
error(char *s)
{
    fprintf(stderr, "ERROR:  %s\n", s);
    exit(1);
}

void
usage()
{
    fprintf(stderr, "usage:  wrparm tdm_data_file\n");
}

void
parwrite(FILE *ifp, char *ifn)
{
   fprintf(ifp, "# %s\n\n", ifn);

   fprintf(ifp, "aca=%9g\n", pa_.aca);
   fprintf(ifp, "acb=%9g\n", pa_.acb);
   fprintf(ifp, "acc=%9g\n", pa_.acc);
   fprintf(ifp, "acp=%9g\n", pa_.acp);
   fprintf(ifp, "adi=%9g\n", pa_.adi);
   fprintf(ifp, "aed=%9g\n", pa_.aed);
   fprintf(ifp, "ama=%9g\n", pa_.ama);
   fprintf(ifp, "ast=%9g\n", pa_.ast);
   fprintf(ifp, "basacc=%d\n", pa_.basacc);
   fprintf(ifp, "bl=%9g\n", pa_.bl );
   fprintf(ifp, "bwa=%9g\n", pa_.bwa);
   fprintf(ifp, "bwb=%9g\n", pa_.bwb);
   fprintf(ifp, "bwc=%9g\n", pa_.bwc);
   fprintf(ifp, "couplr=%d\n", pa_.couplr);
   fprintf(ifp, "d3max=%9g\n", pa_.d3max);
   fprintf(ifp, "dhbmax=%9g\n", pa_.dhbmax);
   fprintf(ifp, "dhbmin=%9g\n", pa_.dhbmin);
   fprintf(ifp, "dihc=%9g\n", pa_.dihc);
   fprintf(ifp, "dt=%9g\n", pa_.dt);
   fprintf(ifp, "f1=%9g\n", pa_.f1);
   fprintf(ifp, "f2=%9g\n", pa_.f2);
   fprintf(ifp, "f3=%9g\n", pa_.f3);
   fprintf(ifp, "f4=%9g\n", pa_.f4);
   fprintf(ifp, "fpma=%9g\n", pa_.fpma);
   fprintf(ifp, "fpmb=%9g\n", pa_.fpmb);
   fprintf(ifp, "fpmc=%9g\n", pa_.fpmc);
   fprintf(ifp, "g1a=%9g\n", pa_.g1a);
   fprintf(ifp, "g1b=%9g\n", pa_.g1b);
   fprintf(ifp, "g1c=%9g\n", pa_.g1c);
   fprintf(ifp, "g2a=%9g\n", pa_.g2a);
   fprintf(ifp, "g2b=%9g\n", pa_.g2b);
   fprintf(ifp, "g2c=%9g\n", pa_.g2c);
   fprintf(ifp, "gba=%9g\n", pa_.gba);
   fprintf(ifp, "gbb=%9g\n", pa_.gbb);
   fprintf(ifp, "gbc=%9g\n", pa_.gbc);
   fprintf(ifp, "gmel=%9g\n", pa_.gmel);
   fprintf(ifp, "gpa=%9g\n", pa_.gpa);
   fprintf(ifp, "gpb=%9g\n", pa_.gpb);
   fprintf(ifp, "gpc=%9g\n", pa_.gpc);
   fprintf(ifp, "icyc=%ld\n", pa_.icyc);
   fprintf(ifp, "ifrmt=%d\n", pa_.ifrmt);
   fprintf(ifp, "isv[0]=%d\n", pa_.isv[0]);
   fprintf(ifp, "isv[1]=%d\n", pa_.isv[1]);
   fprintf(ifp, "isv[2]=%d\n", pa_.isv[2]);
   fprintf(ifp, "isv[3]=%d\n", pa_.isv[3]);
   fprintf(ifp, "isv[4]=%d\n", pa_.isv[4]);
   fprintf(ifp, "isv[5]=%d\n", pa_.isv[5]);
   fprintf(ifp, "itsc=%ld\n", pa_.itsc);
   fprintf(ifp, "itsf=%ld\n", pa_.itsf);
   fprintf(ifp, "itsw=%ld\n", pa_.itsw);
   fprintf(ifp, "jfrmt=%d\n", pa_.jfrmt);
   fprintf(ifp, "k1a=%9g\n", pa_.k1a);
   fprintf(ifp, "k1b=%9g\n", pa_.k1b);
   fprintf(ifp, "k1c=%9g\n", pa_.k1c);
   fprintf(ifp, "k2a=%9g\n", pa_.k2a);
   fprintf(ifp, "k2b=%9g\n", pa_.k2b);
   fprintf(ifp, "k2c=%9g\n", pa_.k2c);
   fprintf(ifp, "k3a=%9g\n", pa_.k3a);
   fprintf(ifp, "k3b=%9g\n", pa_.k3b);
   fprintf(ifp, "k3c=%9g\n", pa_.k3c);
   fprintf(ifp, "k4a=%9g\n", pa_.k4a);
   fprintf(ifp, "k4b=%9g\n", pa_.k4b);
   fprintf(ifp, "k4c=%9g\n", pa_.k4c);
   fprintf(ifp, "k5a=%9g\n", pa_.k5a);
   fprintf(ifp, "k5b=%9g\n", pa_.k5b);
   fprintf(ifp, "k5c=%9g\n", pa_.k5c);
   fprintf(ifp, "kcp=%9g\n", pa_.kcp);
   fprintf(ifp, "kdi=%9g\n", pa_.kdi);
   fprintf(ifp, "ked=%9g\n", pa_.ked);
   fprintf(ifp, "khe=%9g\n", pa_.khe);
   fprintf(ifp, "kim=%9g\n", pa_.kim);
   fprintf(ifp, "kma=%9g\n", pa_.kma);
   fprintf(ifp, "kst=%9g\n", pa_.kst);
   fprintf(ifp, "l1=%9g\n", pa_.l1);
   fprintf(ifp, "l2=%9g\n", pa_.l2);
   fprintf(ifp, "l3=%9g\n", pa_.l3);
   fprintf(ifp, "l4=%9g\n", pa_.l4);
   fprintf(ifp, "m1a=%9g\n", pa_.m1a);
   fprintf(ifp, "m1b=%9g\n", pa_.m1b);
   fprintf(ifp, "m1c=%9g\n", pa_.m1c);
   fprintf(ifp, "m2a=%9g\n", pa_.m2a);
   fprintf(ifp, "m2b=%9g\n", pa_.m2b);
   fprintf(ifp, "m2c=%9g\n", pa_.m2c);
   fprintf(ifp, "m=%d\n", pa_.m);
   fprintf(ifp, "mco=%9g\n", pa_.mco);
   fprintf(ifp, "mcp=%9g\n", pa_.mcp);
   fprintf(ifp, "mdi=%9g\n", pa_.mdi);
   fprintf(ifp, "med=%9g\n", pa_.med);
   fprintf(ifp, "mhe=%9g\n", pa_.mhe);
   fprintf(ifp, "midear=%d\n", pa_.midear);
   fprintf(ifp, "mma=%9g\n", pa_.mma);
   fprintf(ifp, "mmeq=%d\n", pa_.mmeq);
   fprintf(ifp, "mst=%9g\n", pa_.mst);
   fprintf(ifp, "n=%d\n", pa_.n);
   fprintf(ifp, "ncyc=%ld\n", pa_.ncyc);
   fprintf(ifp, "ntsc=%ld\n", pa_.ntsc);
   fprintf(ifp, "ntsf=%ld\n", pa_.ntsf);
   fprintf(ifp, "ntsw=%ld\n", pa_.ntsw);
   fprintf(ifp, "r1a=%9g\n", pa_.r1a);
   fprintf(ifp, "r1b=%9g\n", pa_.r1b);
   fprintf(ifp, "r1c=%9g\n", pa_.r1c);
   fprintf(ifp, "r2a=%9g\n", pa_.r2a);
   fprintf(ifp, "r2b=%9g\n", pa_.r2b);
   fprintf(ifp, "r2c=%9g\n", pa_.r2c);
   fprintf(ifp, "r3a=%9g\n", pa_.r3a);
   fprintf(ifp, "r3b=%9g\n", pa_.r3b);
   fprintf(ifp, "r3c=%9g\n", pa_.r3c);
   fprintf(ifp, "r4a=%9g\n", pa_.r4a);
   fprintf(ifp, "r4b=%9g\n", pa_.r4b);
   fprintf(ifp, "r4c=%9g\n", pa_.r4c);
   fprintf(ifp, "rco=%9g\n", pa_.rco);
   fprintf(ifp, "rcp=%9g\n", pa_.rcp);
   fprintf(ifp, "rdi=%9g\n", pa_.rdi);
   fprintf(ifp, "red=%9g\n", pa_.red);
   fprintf(ifp, "rfa=%9g\n", pa_.rfa);
   fprintf(ifp, "rfb=%9g\n", pa_.rfb);
   fprintf(ifp, "rfc=%9g\n", pa_.rfc);
   fprintf(ifp, "rfz=%9g\n", pa_.rfz);
   fprintf(ifp, "rhe=%9g\n", pa_.rhe);
   fprintf(ifp, "rho=%9g\n", pa_.rho);
   fprintf(ifp, "rim=%9g\n", pa_.rim);
   fprintf(ifp, "rma=%9g\n", pa_.rma);
   fprintf(ifp, "rst=%9g\n", pa_.rst);
   fprintf(ifp, "rvc=%9g\n", pa_.rvc);
   fprintf(ifp, "rve=%9g\n", pa_.rve);
   fprintf(ifp, "stgain=%9g\n", pa_.stgain);
   fprintf(ifp, "stimfn=%s\n", pa_.stimfn);
   fprintf(ifp, "t1a=%9g\n", pa_.t1a);
   fprintf(ifp, "t1b=%9g\n", pa_.t1b);
   fprintf(ifp, "t1c=%9g\n", pa_.t1c);
   fprintf(ifp, "t2a=%9g\n", pa_.t2a);
   fprintf(ifp, "t2b=%9g\n", pa_.t2b);
   fprintf(ifp, "t2c=%9g\n", pa_.t2c);
   fprintf(ifp, "tauhc=%9g\n", pa_.tauhc);
   fprintf(ifp, "vhcmax=%9g\n", pa_.vhcmax);
   fprintf(ifp, "vhcmin=%9g\n", pa_.vhcmin);
   fprintf(ifp, "vihc=%9g\n", pa_.vihc);
   fprintf(ifp, "xhe=%9g\n", pa_.xhe);
   fprintf(ifp, "xl=%9g\n", pa_.xl);
   fprintf(ifp, "yw=%9g\n", pa_.yw);
   fprintf(ifp, "zh=%9g\n", pa_.zh);

}

/* sswab - swap bytes (in place) for n "short ints" */
void
sswab(void *p, int n)
{
    swab(p, p, n * 2); 
}

/* lswab - swap bytes (in place) for n "long ints" */
void
lswab(long *p, int n)
{
    unsigned char *ch, tmp;

    while (n-- > 0) {
	ch = (unsigned char *) p++;
	tmp = ch[3];
	ch[3] = ch[0];
	ch[0] = tmp;
	tmp = ch[2];
	ch[2] = ch[1];
	ch[1] = tmp;
    }
}

/* swap bytes in header  */
void
hdr_swab()
{
    sswab((void *) &pa_.hdrsiz, 6);
    lswab((long *) &pa_.dt, 14);
    sswab((void *) &pa_.m, 21);
    lswab((long *) &pa_.xl, 168);
}

int
main(int ac, char **av)
{
    char *fn1, msg[80];
    int  long_flag = 0;
    FILE *fp1;

    if (av[1][0] == '-') {
        if (av[1][1] == 'l') {
	    long_flag++;
	}
	av++;
	ac--;
    }
    if (ac < 2)
	usage();
    fn1 = av[1];

    if ((fp1 = fopen(fn1, "rb")) == NULL) {
	sprintf(msg, "can't open %s\n", fn1);
	error(msg);
    }
    if (fread((char *) &pa_, sizeof(pa_), 1, fp1) < 1) {
	error("reading header\n");
    }
    fclose(fp1);
    if (pa_.ifrmt > 255)
        hdr_swab();
    if (long_flag)
	parwrite(stdout, fn1);
    else
        wrpar(stdout);

    return(0);		/* done */
}
